routes/web.php
<?php

use App\Http\Controllers\BackendController;
use Illuminate\Support\Facades\Route;
use App\Http\Controllers\OffreController;
use App\Models\Entreprise;
use App\Http\Controllers\EntrepriseController;
use App\Http\Controllers\UserController;
use App\Http\Controllers\AptitudeController;
use App\Http\Controllers\OptionController;
use App\Http\Controllers\PromotionController;
use App\Http\Controllers\EleveController;
use App\Http\Controllers\PromotionEleveController;
use App\Http\Controllers\EntretienController;
use App\Http\Controllers\ProfesseurController;
use App\Http\Controllers\FicheController;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/
Route::get('/',[OffreController::class, 'welcome'])->name('welcome');
Route::get('/mentions',[BackendController::class, 'mentions'])->name('mentions');
Route::middleware(['auth'])->group(function () {
    Route::get('fiche/pdf', [FicheController::class, 'testViewPDF'])->name('testViewPDF');
    Route::get('fiche/export/{id}', [FicheController::class, 'getPostPdf'])->name('getPostPdf');
    Route::get('/', [OffreController::class, 'welcome'])->name('welcome');
    Route::post('/download', [BackendController::class, 'download'])->name('download');
    Route::get('profil', [UserController::class, 'profil'])->name('profil');
    Route::post('profil', [UserController::class, 'profilUpdate'])->name('profilUpdate');
    Route::post('/contact', [BackendController::class ,'contact'])->name('contact');
    Route::prefix('admin')->group(function () {
        Route::resource('aptitudes', AptitudeController::class);
        Route::resource('offres', OffreController::class);
        Route::resource('entreprises', EntrepriseController::class);
        Route::resource('users', UserController::class);
        Route::resource('option', OptionController::class);
        Route::resource('promotion', PromotionController::class);
        Route::resource('eleve', EleveController::class);
        Route::resource('eleve_promotion', PromotionEleveController::class);
        Route::resource('entretien', EntretienController::class);
        Route::resource('professeur', ProfesseurController::class);
        Route::resource('fiche', FicheController::class);
        Route::get('/', [BackendController::class ,'dashboard'])->name('dashboard');
    });
});
require __DIR__.'/auth.php';

app/Models/Promotion.php
<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;

class Promotion extends Model
{


    protected $fillable = ['id','professeur_id', 'libelle'];

    public function professeur()
    {
      return $this->belongsTo(Professeur::class);
    }

    public function eleves()
    {
      return $this->BelongsToMany(Eleve::class)->withTimestamps();
    }

    public function options()
    {
      return $this->hasMany(Option::class);
    }

    use HasFactory;

}
//des eleves - un prof - des options

app/Http/Controllers/PromotionController.php
<?php

namespace App\Http\Controllers;

use App\Models\{Promotion, Professeur};
use Illuminate\Http\Request;

class PromotionController extends Controller
{
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {
        $promotions = Promotion::get()->all();
        return view('Promotions/promotions', compact('promotions'));
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        $professeurs = Professeur::all();
        return view('Promotions/create', compact('professeurs'));
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(Request $request)
    {
      $data = request()->validate([
        'libelle'=>'required',
        'professeur_id'=>'required',
      ]);
      $promotion = Promotion::create($data);
    return redirect()->route('promotion.index');
    }

    /**
     * Display the specified resource.
     *
     * @param  \App\Models\Promotion  $promotion
     * @return \Illuminate\Http\Response
     */
    public function show(Promotion $promotion)
    {
        //
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  \App\Models\Promotion  $promotion
     * @return \Illuminate\Http\Response
     */
    public function edit(Promotion $promotion)
    {
      $professeurs = Professeur::get()->all();
      return view('Promotions/edit', compact('professeurs', 'promotion'));
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  \App\Models\Promotion  $promotion
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, Promotion $promotion)
    {
      $request->validate([
        'libelle' => 'required',
        'professeur_id' => 'required',
      ]);
      $promotion->update($request->all());
      return redirect()->route('promotion.index')
                      ->with('success', 'Promotion modifiée');
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  \App\Models\Promotion  $promotion
     * @return \Illuminate\Http\Response
     */
    public function destroy($id)
    {
        $promotion = Promotion::find($id);
        $promotion->delete();
        return redirect()->route('promotion.index')
                        ->with('success', 'Promotion supprimée');
    }
}

resources/views/Promotions/create.blade.php
@extends('backend.template')

@section('title')
Créer promotion
@endsection

@section('content')
<form method="POST" action="{{ route('promotion.store') }}">
    @csrf
    <div class="field">
        <div class="select">
          <label for="">Prof : </label>
          <select name="professeur_id">
              @foreach($professeurs as $prof)
                    <option value="{{$prof->id}}">{{ $prof->user->nom . " " . $prof->user->prenom}}</option>
                @endforeach
            </select>
        </div>
        <div class="">
          <label for="">Libelle : </label>
          <input type="text" name="libelle" value="{{old('libelle')}}">
        </div>
        <button type="submit" class="btn btn-primary float-right">Submit</button>
    </div>
</form>
@endsection

resources/views/Promotions/edit.blade.php
@extends('backend.template')

@section('title')
Modification promotion
@endsection

@section('content')
<div class="container mt-5">
    <form action="{{ route('promotion.update', $promotion->id) }}" method="POST">
        @csrf
        @method('PUT')
        <div class="form-group">
          <label>Libelle</label>
          <input type="text" class="form-control" name="libelle" value="{{ $promotion->libelle }}">
        </div>
        <div class="form-group">
          <label>Professeurs</label>
          <select name="professeur_id">
              @foreach($professeurs as $professeur)
                @if($promotion->professeur_id == $professeur->id)
                  <option value="{{ $professeur->id }}" selected="selected">{{ $professeur->user->nom . " " . $professeur->user->prenom }}</option>
                @else
                  <option value="{{ $professeur->id }}">{{ $professeur->user->nom . " " . $professeur->user->prenom }}</option>
                @endif
              @endforeach
          </select>
        </div>
        <button type="submit" class="btn btn-primary float-right">Submit</button>
    </form>
</div>
@endsection

resources/views/Promotions/promotions.blade.php
@extends('backend.template')

@section('title')
Promotions
@endsection

@section('content')

<div class="row">
  <div class="col-lg-12 margin-tb">
      <div class="float-start">
          <h2>CRUD Promotion</h2>
      </div>
      <div class="float-end">
          <a class="btn btn-outline-success"  href="{{ route('promotion.create') }}">Ajouter une nouvelle promotion</a>
      </div>
  </div>
</div>

<div class="center padd20">
  <table class="table table-bordered ">
    <tr>
      <th>Libelle</th>
      <th>Professeur</th>
      <th>Actions</th>
      @foreach($promotions as $promotion)
      <tr>
        <td>{{$promotion->libelle}}</td>
        <td>{{$promotion->professeur->user->nom}} {{$promotion->professeur->user->prenom}}</td>
        <td style="text-align: center;">
              <form action="{{ route('promotion.destroy',$promotion->id) }}" method="POST">
                <a class="btn btn-outline-success btn-edit" href="{{ route('promotion.edit',$promotion->id) }}"></a>
                @csrf
                @method('DELETE')
                <button type="submit" class="btn btn-outline-danger btn-delete"></button>
            </form>
          </td>
        </tr>
    @endforeach
  </table>
</div>


@endsection